## mosquitto 1.3.4

=== CMakeLists.txt ===
# This is a cmake script.

set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(mosquitto)

cmake_minimum_required(VERSION 2.6)

set (VERSION 1.3.4)

if (WIN32)
	execute_process(COMMAND cmd /c echo %DATE% %TIME% OUTPUT_VARIABLE TIMESTAMP
			OUTPUT_STRIP_TRAILING_WHITESPACE)
else (WIN32)
	execute_process(COMMAND date "+%F %T%z" OUTPUT_VARIABLE TIMESTAMP
			OUTPUT_STRIP_TRAILING_WHITESPACE)
endif (WIN32)

add_definitions (-DCMAKE -DVERSION=\"${VERSION}\" -DTIMESTAMP=\"${TIMESTAMP}\")

if (WIN32)
	set (BINDIR .)
	set (SBINDIR .)
	set (SYSCONFDIR .)
	set (LIBDIR .)
	set (INCLUDEDIR include)
	set (DATAROOTDIR share)
	set (MANDIR man)
    set (SHAREDEST .)
    add_definitions("-D_CRT_SECURE_NO_WARNINGS")
else (WIN32)
	set (BINDIR bin)
	set (SBINDIR sbin)
	if (${CMAKE_INSTALL_PREFIX} STREQUAL /usr)
		set (SYSCONFDIR /etc/mosquitto)
	else (${CMAKE_INSTALL_PREFIX} STREQUAL /usr)
		set (SYSCONFDIR etc/mosquitto)
	endif (${CMAKE_INSTALL_PREFIX} STREQUAL /usr)
	
	set (LIBDIR lib${LIB_SUFFIX})
	set (INCLUDEDIR include)
	set (DATAROOTDIR share)
	set (MANDIR ${DATAROOTDIR}/man)
	set (SHAREDIR ${DATAROOTDIR}/mosquitto)
endif (WIN32)

option(WITH_TLS
	"Include SSL/TLS support?" ON)
option(WITH_TLS_PSK
	"Include TLS-PSK support (requires WITH_TLS)?" ON)
if (${WITH_TLS} STREQUAL ON)
	find_package(OpenSSL REQUIRED)
	add_definitions("-DWITH_TLS")
	if (${WITH_TLS_PSK} STREQUAL ON)
		add_definitions("-DWITH_TLS_PSK")
	endif (${WITH_TLS_PSK} STREQUAL ON)
else (${WITH_TLS} STREQUAL ON)
	set (OPENSSL_INCLUDE_DIR "")
endif (${WITH_TLS} STREQUAL ON)

option(WITH_SRV "Include SRV lookup support?" ON)

# ========================================
# Include projects
# ========================================

add_subdirectory(lib)
add_subdirectory(client)
add_subdirectory(src)
add_subdirectory(man)

# ========================================
# Install config file
# ========================================

install(FILES mosquitto.conf aclfile.example pskfile.example pwfile.example DESTINATION ${SYSCONFDIR})

=== Makefile ===
include config.mk

DIRS=lib client src
DOCDIRS=man
DISTDIRS=man

.PHONY : all mosquitto docs binary clean reallyclean test install uninstall dist sign copy

all : mosquitto docs

docs :
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d}; done

binary : mosquitto

mosquitto :
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d}; done

clean :
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} clean; done
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} clean; done
	$(MAKE) -C test clean

reallyclean : 
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} reallyclean; done
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} reallyclean; done
	$(MAKE) -C test reallyclean
	-rm -f *.orig

test : mosquitto
	$(MAKE) -C test test

install : mosquitto
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} install; done
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} install; done
	$(INSTALL) -d ${DESTDIR}/etc/mosquitto
	$(INSTALL) -m 644 mosquitto.conf ${DESTDIR}/etc/mosquitto/mosquitto.conf.example
	$(INSTALL) -m 644 aclfile.example ${DESTDIR}/etc/mosquitto/aclfile.example
	$(INSTALL) -m 644 pwfile.example ${DESTDIR}/etc/mosquitto/pwfile.example
	$(INSTALL) -m 644 pskfile.example ${DESTDIR}/etc/mosquitto/pskfile.example

uninstall :
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} uninstall; done
	rm -f ${DESTDIR}/etc/mosquitto/mosquitto.conf
	rm -f ${DESTDIR}/etc/mosquitto/aclfile.example
	rm -f ${DESTDIR}/etc/mosquitto/pwfile.example
	rm -f ${DESTDIR}/etc/mosquitto/pskfile.example

dist : reallyclean
	set -e; for d in ${DISTDIRS}; do $(MAKE) -C $${d} dist; done
	
	echo $$(hg log -r . --template "{node}") > changeset
	mkdir -p dist/mosquitto-${VERSION}
	cp -r client changeset examples installer lib logo man misc security service src test ChangeLog.txt CMakeLists.txt LICENSE.txt LICENSE-3rd-party.txt Makefile compiling.txt config.h config.mk readme.txt readme-windows.txt mosquitto.conf aclfile.example pskfile.example pwfile.example dist/mosquitto-${VERSION}/
	cd dist; tar -zcf mosquitto-${VERSION}.tar.gz mosquitto-${VERSION}/
	set -e; for m in man/*.xml; \
		do \
		hfile=$$(echo $${m} | sed -e 's#man/\(.*\)\.xml#\1#' | sed -e 's/\./-/g'); \
		$(XSLTPROC) $(DB_HTML_XSL) $${m} > dist/$${hfile}.html; \
	done


sign : dist
	cd dist; gpg --detach-sign -a mosquitto-${VERSION}.tar.gz

copy : sign
	cd dist; scp mosquitto-${VERSION}.tar.gz mosquitto-${VERSION}.tar.gz.asc mosquitto:site/mosquitto.org/files/source/
	cd dist; scp *.html mosquitto:site/mosquitto.org/man/
	scp ChangeLog.txt mosquitto:site/mosquitto.org/

=== client/CMakeLists.txt ===
include_directories(${mosquitto_SOURCE_DIR}/lib
			${STDBOOL_H_PATH} ${STDINT_H_PATH})
link_directories(${mosquitto_BINARY_DIR}/lib)

if (${WITH_SRV} STREQUAL ON)
	add_definitions("-DWITH_SRV")
endif (${WITH_SRV} STREQUAL ON)

add_executable(mosquitto_pub pub_client.c)
add_executable(mosquitto_sub sub_client.c)

target_link_libraries(mosquitto_pub libmosquitto)
target_link_libraries(mosquitto_sub libmosquitto)

install(TARGETS mosquitto_pub RUNTIME DESTINATION ${BINDIR} LIBRARY DESTINATION ${LIBDIR})
install(TARGETS mosquitto_sub RUNTIME DESTINATION ${BINDIR} LIBRARY DESTINATION ${LIBDIR})

=== client/Makefile ===
include ../config.mk

.PHONY: all install uninstall reallyclean clean

all : mosquitto_pub mosquitto_sub

mosquitto_pub : pub_client.o ../lib/libmosquitto.so.${SOVERSION}
	${CC} $< -o $@ ${CLIENT_LDFLAGS}

mosquitto_sub : sub_client.o ../lib/libmosquitto.so.${SOVERSION}
	${CC} $< -o $@ ${CLIENT_LDFLAGS}

pub_client.o : pub_client.c ../lib/libmosquitto.so.${SOVERSION}
	${CC} -c $< -o $@ ${CLIENT_CFLAGS}

sub_client.o : sub_client.c ../lib/libmosquitto.so.${SOVERSION}
	${CC} -c $< -o $@ ${CLIENT_CFLAGS}

../lib/libmosquitto.so.${SOVERSION} :
	$(MAKE) -C ../lib

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/bin
	$(INSTALL) -s --strip-program=$(STRIP) mosquitto_pub ${DESTDIR}${prefix}/bin/mosquitto_pub
	$(INSTALL) -s --strip-program=$(STRIP) mosquitto_sub ${DESTDIR}${prefix}/bin/mosquitto_sub

uninstall :
	-rm -f ${DESTDIR}${prefix}/bin/mosquitto_pub
	-rm -f ${DESTDIR}${prefix}/bin/mosquitto_sub

reallyclean : clean

clean : 
	-rm -f *.o mosquitto_pub mosquitto_sub

=== lib/CMakeLists.txt ===
add_subdirectory(cpp)

option(WITH_THREADING "Include client library threading support?" ON)
if (${WITH_THREADING} STREQUAL ON)
	add_definitions("-DWITH_THREADING")
	if (WIN32)
		set (PTHREAD_LIBRARIES C:\\pthreads\\Pre-built.2\\lib\\x86\\pthreadVC2.lib)
		set (PTHREAD_INCLUDE_DIR C:\\pthreads\\Pre-built.2\\include)
	else (WIN32)
		set (PTHREAD_LIBRARIES pthread)
		set (PTHREAD_INCLUDE_DIR "")
	endif (WIN32)
else (${WITH_THREADING} STREQUAL ON)
	set (PTHREAD_LIBRARIES "")
	set (PTHREAD_INCLUDE_DIR "")
endif (${WITH_THREADING} STREQUAL ON)

include_directories(${mosquitto_SOURCE_DIR} ${mosquitto_SOURCE_DIR}/lib
			${STDBOOL_H_PATH} ${STDINT_H_PATH}
			${OPENSSL_INCLUDE_DIR} ${PTHREAD_INCLUDE_DIR})
link_directories(${mosquitto_SOURCE_DIR}/lib)

add_library(libmosquitto SHARED
	logging_mosq.c logging_mosq.h
	memory_mosq.c memory_mosq.h
	messages_mosq.c messages_mosq.h
	mosquitto.c mosquitto.h
	mosquitto_internal.h
	mqtt3_protocol.h
	net_mosq.c net_mosq.h
	read_handle.c read_handle.h
	read_handle_client.c
	read_handle_shared.c
	send_client_mosq.c
	send_mosq.c send_mosq.h
	srv_mosq.c
	thread_mosq.c
	time_mosq.c
	tls_mosq.c
	util_mosq.c util_mosq.h
	will_mosq.c will_mosq.h)

set (LIBRARIES ${OPENSSL_LIBRARIES} ${PTHREAD_LIBRARIES})

if (UNIX AND NOT APPLE)
	set (LIBRARIES ${LIBRARIES} rt)
endif (UNIX AND NOT APPLE)

if (WIN32)
	set (LIBRARIES ${LIBRARIES} ws2_32)
endif (WIN32)

if (${WITH_SRV} STREQUAL ON)
	add_definitions("-DWITH_SRV")
	set (LIBRARIES ${LIBRARIES} cares)
endif (${WITH_SRV} STREQUAL ON)

target_link_libraries(libmosquitto ${LIBRARIES})

set_target_properties(libmosquitto PROPERTIES
	OUTPUT_NAME mosquitto
	VERSION ${VERSION}
	SOVERSION 1
)

install(TARGETS libmosquitto RUNTIME DESTINATION ${BINDIR} LIBRARY DESTINATION ${LIBDIR})
install(FILES mosquitto.h DESTINATION ${INCLUDEDIR})

if (UNIX)
	install(CODE "EXEC_PROGRAM(/sbin/ldconfig)")
endif (UNIX)

=== lib/Makefile ===
include ../config.mk

.PHONY : really clean install

MOSQ_OBJS=mosquitto.o \
		  logging_mosq.o \
		  memory_mosq.o \
		  messages_mosq.o \
		  net_mosq.o \
		  read_handle.o \
		  read_handle_client.o \
		  read_handle_shared.o \
		  send_mosq.o \
		  send_client_mosq.o \
		  srv_mosq.o \
		  thread_mosq.o \
		  time_mosq.o \
		  tls_mosq.o \
		  util_mosq.o \
		  will_mosq.o

all : libmosquitto.so.${SOVERSION} libmosquitto.a
	$(MAKE) -C cpp
	$(MAKE) -C python

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/lib${LIB_SUFFIX}/
	$(INSTALL) -s --strip-program=$(STRIP) libmosquitto.so.${SOVERSION} ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquitto.so.${SOVERSION}
	ln -sf libmosquitto.so.${SOVERSION} ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquitto.so
	$(INSTALL) -d ${DESTDIR}${prefix}/include/
	$(INSTALL) mosquitto.h ${DESTDIR}${prefix}/include/mosquitto.h
	$(MAKE) -C cpp install
	$(MAKE) -C python install

uninstall :
	-rm -f ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquitto.so.${SOVERSION}
	-rm -f ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquitto.so
	-rm -f ${DESTDIR}${prefix}/include/mosquitto.h

reallyclean : clean

clean :
	-rm -f *.o libmosquitto.so.${SOVERSION} libmosquitto.so libmosquitto.a
	$(MAKE) -C cpp clean
	$(MAKE) -C python clean

libmosquitto.so.${SOVERSION} : ${MOSQ_OBJS}
	$(CC) -shared $(LIB_LDFLAGS) $^ -o $@ ${LIB_LIBS}

libmosquitto.a : ${MOSQ_OBJS}
	$(AR) cr $@ $^
mosquitto.o : mosquitto.c mosquitto.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

logging_mosq.o : logging_mosq.c logging_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

messages_mosq.o : messages_mosq.c messages_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

memory_mosq.o : memory_mosq.c memory_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

net_mosq.o : net_mosq.c net_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

read_handle.o : read_handle.c read_handle.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

read_handle_client.o : read_handle_client.c read_handle.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

read_handle_shared.o : read_handle_shared.c read_handle.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

send_mosq.o : send_mosq.c send_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

send_client_mosq.o : send_client_mosq.c send_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

srv_mosq.o : srv_mosq.c
	$(CC) $(LIB_CFLAGS) -c $< -o $@

thread_mosq.o : thread_mosq.c
	$(CC) $(LIB_CFLAGS) -c $< -o $@

time_mosq.o : time_mosq.c
	$(CC) $(LIB_CFLAGS) -c $< -o $@

tls_mosq.o : tls_mosq.c
	$(CC) $(LIB_CFLAGS) -c $< -o $@

util_mosq.o : util_mosq.c util_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

will_mosq.o : will_mosq.c will_mosq.h
	$(CC) $(LIB_CFLAGS) -c $< -o $@

=== man/Makefile ===
include ../config.mk

.PHONY : all clean install uninstall dist 

all :  mosquitto.8 mosquitto-tls.7 mosquitto.conf.5 mosquitto_passwd.1 mosquitto_pub.1 mosquitto_sub.1 mqtt.7 libmosquitto.3

clean :

reallyclean : clean
	-rm -f *.orig

dist : mosquitto.8 mosquitto-tls.7 mosquitto.conf.5 mosquitto_passwd.1 mosquitto_pub.1 mosquitto_sub.1 mqtt.7 libmosquitto.3

install :
	$(INSTALL) -d ${DESTDIR}$(mandir)/man8
	$(INSTALL) -m 644 mosquitto.8 ${DESTDIR}${mandir}/man8/mosquitto.8
	$(INSTALL) -d ${DESTDIR}$(mandir)/man5
	$(INSTALL) -m 644 mosquitto.conf.5 ${DESTDIR}${mandir}/man5/mosquitto.conf.5
	$(INSTALL) -d ${DESTDIR}$(mandir)/man1
	$(INSTALL) -m 644 mosquitto_passwd.1 ${DESTDIR}${mandir}/man1/mosquitto_passwd.1
	$(INSTALL) -m 644 mosquitto_pub.1 ${DESTDIR}${mandir}/man1/mosquitto_pub.1
	$(INSTALL) -m 644 mosquitto_sub.1 ${DESTDIR}${mandir}/man1/mosquitto_sub.1
	$(INSTALL) -d ${DESTDIR}$(mandir)/man7
	$(INSTALL) -m 644 mqtt.7 ${DESTDIR}${mandir}/man7/mqtt.7
	$(INSTALL) -m 644 mosquitto-tls.7 ${DESTDIR}${mandir}/man7/mosquitto-tls.7
	$(INSTALL) -d ${DESTDIR}$(mandir)/man3
	$(INSTALL) -m 644 libmosquitto.3 ${DESTDIR}${mandir}/man3/libmosquitto.3

uninstall :
	-rm -f ${DESTDIR}${mandir}/man8/mosquitto.8
	-rm -f ${DESTDIR}${mandir}/man5/mosquitto.conf.5
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_passwd.1
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_pub.1
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_sub.1
	-rm -f ${DESTDIR}${mandir}/man7/mqtt.7
	-rm -f ${DESTDIR}${mandir}/man7/mosquitto-tls.7
	-rm -f ${DESTDIR}${mandir}/man3/libmosquitto.3

mosquitto.8 : mosquitto.8.xml
	$(XSLTPROC) $^

mosquitto.conf.5 : mosquitto.conf.5.xml manpage.xsl
	$(XSLTPROC) $<

mosquitto_passwd.1 : mosquitto_passwd.1.xml
	$(XSLTPROC) $^

mosquitto_pub.1 : mosquitto_pub.1.xml
	$(XSLTPROC) $^

mosquitto_sub.1 : mosquitto_sub.1.xml
	$(XSLTPROC) $^

mqtt.7 : mqtt.7.xml
	$(XSLTPROC) $^

mosquitto-tls.7 : mosquitto-tls.7.xml
	$(XSLTPROC) $^

libmosquitto.3 : libmosquitto.3.xml
	$(XSLTPROC) $^

potgen :
	 xml2po -o po/mosquitto/mosquitto.8.pot mosquitto.8.xml
	 xml2po -o po/mosquitto.conf/mosquitto.conf.5.pot mosquitto.conf.5.xml
	 xml2po -o po/mosquitto_passwd/mosquitto_passwd.1.pot mosquitto_passwd.1.xml
	 xml2po -o po/mosquitto_pub/mosquitto_pub.1.pot mosquitto_pub.1.xml
	 xml2po -o po/mosquitto_sub/mosquitto_sub.1.pot mosquitto_sub.1.xml
	 xml2po -o po/mqtt/mqtt.7.pot mqtt.7.xml
	 xml2po -o po/mosquitto-tls/mosquitto-tls.7.pot mosquitto-tls.7.xml
	 xml2po -o po/libmosquitto/libmosquitto.3.pot libmosquitto.3.xml

# To merge new translations do:
# /usr/bin/xml2po -p de.po chapter1.xml > chapter1.de.xml

=== src/CMakeLists.txt ===
include_directories(${mosquitto_SOURCE_DIR} ${mosquitto_SOURCE_DIR}/src
		${mosquitto_SOURCE_DIR}/lib ${OPENSSL_INCLUDE_DIR}
		${STDBOOL_H_PATH} ${STDINT_H_PATH})

set (MOSQ_SRCS
	conf.c
	context.c
	database.c
	lib_load.h
	logging.c
	loop.c
	../lib/memory_mosq.c ../lib/memory_mosq.h
	mosquitto.c
	mosquitto_broker.h
	net.c
	../lib/net_mosq.c ../lib/net_mosq.h
	persist.c persist.h
	read_handle.c read_handle_client.c read_handle_server.c
	../lib/read_handle_shared.c ../lib/read_handle.h
	subs.c
	security.c security_default.c
	../lib/send_client_mosq.c ../lib/send_mosq.h
	../lib/send_mosq.c ../lib/send_mosq.h
	send_server.c
	sys_tree.c
	../lib/time_mosq.c
	../lib/tls_mosq.c
	../lib/util_mosq.c ../lib/util_mosq.h
	../lib/will_mosq.c ../lib/will_mosq.h)

option(INC_BRIDGE_SUPPORT
	"Include bridge support for connecting to other brokers?" ON)
if (${INC_BRIDGE_SUPPORT} STREQUAL ON)
	set (MOSQ_SRCS ${MOSQ_SRCS} bridge.c)
	add_definitions("-DWITH_BRIDGE")
endif (${INC_BRIDGE_SUPPORT} STREQUAL ON)


option(USE_LIBWRAP
	"Include tcp-wrappers support?" OFF)

if (${USE_LIBWRAP} STREQUAL ON)
	set (MOSQ_LIBS ${MOSQ_LIBS} wrap)
	add_definitions("-DWITH_WRAP")
endif (${USE_LIBWRAP} STREQUAL ON)

option(INC_DB_UPGRADE
	"Include database upgrade support? (recommended)" ON)

option(INC_MEMTRACK
	"Include memory tracking support?" ON)
if (${INC_MEMTRACK} STREQUAL ON)
	add_definitions("-DWITH_MEMORY_TRACKING")
endif (${INC_MEMTRACK} STREQUAL ON)

option(WITH_PERSISTENCE
	"Include persistence support?" ON)
if (${WITH_PERSISTENCE} STREQUAL ON)
	add_definitions("-DWITH_PERSISTENCE")
endif (${WITH_PERSISTENCE} STREQUAL ON)

option(WITH_SYS_TREE
	"Include $SYS tree support?" ON)
if (${WITH_SYS_TREE} STREQUAL ON)
	add_definitions("-DWITH_SYS_TREE")
endif (${WITH_SYS_TREE} STREQUAL ON)

if (WIN32 OR CYGWIN)
	set (MOSQ_SRCS ${MOSQ_SRCS} service.c)
endif (WIN32 OR CYGWIN)

add_definitions (-DWITH_BROKER)

add_executable(mosquitto ${MOSQ_SRCS})

set (MOSQ_LIBS ${OPENSSL_LIBRARIES})

if (UNIX)
	if (APPLE)
		set (MOSQ_LIBS ${MOSQ_LIBS} dl m)
	else (APPLE)
		set (MOSQ_LIBS ${MOSQ_LIBS} rt dl m)
	endif (APPLE)
endif (UNIX)

if (WIN32)
	set (MOSQ_LIBS ${MOSQ_LIBS} ws2_32)
endif (WIN32)

target_link_libraries(mosquitto ${MOSQ_LIBS})

install(TARGETS mosquitto RUNTIME DESTINATION ${SBINDIR} LIBRARY DESTINATION ${LIBDIR})
install(FILES mosquitto_plugin.h DESTINATION ${INCLUDEDIR})


if (${WITH_TLS} STREQUAL ON)
	add_executable(mosquitto_passwd mosquitto_passwd.c)
	target_link_libraries(mosquitto_passwd ${OPENSSL_LIBRARIES})
	install(TARGETS mosquitto_passwd RUNTIME DESTINATION ${BINDIR} LIBRARY DESTINATION ${LIBDIR})
endif (${WITH_TLS} STREQUAL ON)

if (UNIX)
	install(CODE "EXEC_PROGRAM(/sbin/ldconfig)")
endif (UNIX)

=== src/Makefile ===
include ../config.mk

.PHONY: all install uninstall clean reallyclean

ifeq ($(WITH_TLS),yes)
all : mosquitto mosquitto_passwd
else
all : mosquitto
endif

mosquitto : mosquitto.o bridge.o conf.o context.o database.o logging.o loop.o memory_mosq.o persist.o net.o net_mosq.o read_handle.o read_handle_client.o read_handle_server.o read_handle_shared.o security.o security_default.o send_client_mosq.o send_mosq.o send_server.o service.o subs.o sys_tree.o time_mosq.o tls_mosq.o util_mosq.o will_mosq.o
	${CC} $^ -o $@ ${LDFLAGS} $(BROKER_LIBS)

mosquitto.o : mosquitto.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@ -DCHANGESET=\"$$(cat ../changeset)\"

bridge.o : bridge.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@
	
conf.o : conf.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@
	
context.o : context.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

database.o : database.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

logging.o : logging.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

loop.o : loop.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

memory_mosq.o : ../lib/memory_mosq.c ../lib/memory_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

net.o : net.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

net_mosq.o : ../lib/net_mosq.c ../lib/net_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@
	
persist.o : persist.c persist.h mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@
	
read_handle.o : read_handle.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_client.o : read_handle_client.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_server.o : read_handle_server.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_shared.o : ../lib/read_handle_shared.c ../lib/read_handle.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

security.o : security.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

security_default.o : security_default.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

send_client_mosq.o : ../lib/send_client_mosq.c ../lib/send_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

send_mosq.o : ../lib/send_mosq.c ../lib/send_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

send_server.o : send_server.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

service.o : service.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

subs.o : subs.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

sys_tree.o : sys_tree.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

time_mosq.o : ../lib/time_mosq.c ../lib/time_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

tls_mosq.o : ../lib/tls_mosq.c
	${CC} $(BROKER_CFLAGS) -c $< -o $@

util_mosq.o : ../lib/util_mosq.c ../lib/util_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

will_mosq.o : ../lib/will_mosq.c ../lib/will_mosq.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

mosquitto_passwd : mosquitto_passwd.o
	${CC} $^ -o $@ ${LDFLAGS} $(PASSWD_LIBS)

mosquitto_passwd.o : mosquitto_passwd.c
	${CC} $(CFLAGS) ${CPPFLAGS} -c $< -o $@

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/sbin
	$(INSTALL) -s --strip-program=$(STRIP) mosquitto ${DESTDIR}${prefix}/sbin/mosquitto
	$(INSTALL) mosquitto_plugin.h ${DESTDIR}${prefix}/include/mosquitto_plugin.h
ifeq ($(WITH_TLS),yes)
	$(INSTALL) -s --strip-program=$(STRIP) mosquitto_passwd ${DESTDIR}${prefix}/bin/mosquitto_passwd
endif

uninstall :
	-rm -f ${DESTDIR}${prefix}/sbin/mosquitto
	-rm -f ${DESTDIR}${prefix}/include/mosquitto_plugin.h
	-rm -f ${DESTDIR}${prefix}/bin/mosquitto_passwd

clean : 
	-rm -f *.o mosquitto mosquitto_passwd

reallyclean : clean
	-rm -rf *.orig *.db

=== lib/cpp/Makefile ===
include ../../config.mk

ifneq ($(UNAME),SunOS)
	LIB_LDFLAGS:=$(LDFLAGS) -Wl,-soname,libmosquittopp.so.${SOVERSION}
endif

.PHONY : clean install

all : libmosquittopp.so.${SOVERSION}

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/lib${LIB_SUFFIX}/
	$(INSTALL) -s --strip-program=$(STRIP) libmosquittopp.so.${SOVERSION} ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquittopp.so.${SOVERSION}
	ln -sf libmosquittopp.so.${SOVERSION} ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquittopp.so
	$(INSTALL) -d ${DESTDIR}${prefix}/include/
	$(INSTALL) mosquittopp.h ${DESTDIR}${prefix}/include/mosquittopp.h
	
uninstall :
	-rm -f ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquittopp.so.${SOVERSION}
	-rm -f ${DESTDIR}${prefix}/lib${LIB_SUFFIX}/libmosquittopp.so
	-rm -f ${DESTDIR}${prefix}/include/mosquittopp.h

clean :
	-rm -f *.o libmosquittopp.so.${SOVERSION}

libmosquittopp.so.${SOVERSION} : mosquittopp.o
	$(CXX) -shared $(LIB_LDFLAGS) $< -o $@ ../libmosquitto.so.${SOVERSION}

mosquittopp.o : mosquittopp.cpp mosquittopp.h
	$(CXX) $(LIB_CXXFLAGS) -c $< -o $@

=== lib/python/Makefile ===
include ../../config.mk

# Set DESTDIR if it isn't given
DESTDIR?=/

.PHONY : all clean install

ifeq ($(WITH_PYTHON),yes)
all : mosquitto.pyc
else
all :
endif

ifeq ($(WITH_PYTHON),yes)
install : all
	python ./setup.py install --prefix=${prefix} --root=${DESTDIR}
else
install :
endif

mosquitto.pyc : mosquitto.py
	python ./setup.py build

clean :
	-rm -rf build mosquitto.pyc __pycache__

=== test/broker/Makefile ===
.PHONY: all clean test
.NOTPARALLEL:

all :

clean : 
	$(MAKE) -C c clean

test-compile : 
	$(MAKE) -C c

test : test-compile 01 02 03 04 05 06 07 08 09 10

01 :
	./01-connect-success.py
	./01-connect-invalid-protonum.py
	./01-connect-invalid-id-0.py
	./01-connect-invalid-id-0-311.py
	./01-connect-invalid-id-missing.py
	./01-connect-anon-denied.py
	./01-connect-uname-no-password-denied.py
	./01-connect-uname-password-denied.py
	./01-connect-uname-password-success.py

02 :
	./02-subscribe-qos0.py
	./02-subscribe-qos1.py
	./02-subscribe-qos2.py
	./02-subpub-qos0.py
	./02-subpub-qos1.py
	./02-subpub-qos2.py
	./02-unsubscribe-qos0.py
	./02-unsubscribe-qos1.py
	./02-unsubscribe-qos2.py

03 :
	./03-publish-qos1.py
	./03-publish-qos2.py
	./03-publish-b2c-timeout-qos1.py
	./03-publish-b2c-disconnect-qos1.py
	./03-publish-c2b-timeout-qos2.py
	./03-publish-c2b-disconnect-qos2.py
	./03-publish-b2c-timeout-qos2.py
	./03-publish-b2c-disconnect-qos2.py
	./03-pattern-matching.py

04 :
	./04-retain-qos0.py
	./04-retain-qos0-fresh.py
	./04-retain-qos0-repeated.py
	./04-retain-qos1-qos0.py
	./04-retain-qos0-clear.py

05 :
	./05-clean-session-qos1.py 

06 :
	./06-bridge-reconnect-local-out.py
	./06-bridge-br2b-disconnect-qos1.py
	./06-bridge-br2b-disconnect-qos2.py
	./06-bridge-b2br-disconnect-qos1.py
	./06-bridge-b2br-disconnect-qos2.py

07 :
	./07-will-qos0.py
	./07-will-null.py
	./07-will-acl-denied.py
	./07-will-null-topic.py

08 :
	./08-ssl-connect-no-auth.py
	./08-ssl-connect-no-auth-wrong-ca.py
	./08-ssl-connect-cert-auth.py
	./08-ssl-connect-cert-auth-without.py
	./08-ssl-connect-cert-auth-expired.py
	./08-ssl-connect-cert-auth-revoked.py
	./08-ssl-connect-cert-auth-crl.py
	./08-ssl-connect-identity.py
	./08-ssl-connect-no-identity.py
	./08-ssl-bridge.py
	./08-tls-psk-pub.py
	./08-tls-psk-bridge.py

09 :
	./09-plugin-auth-unpwd-success.py
	./09-plugin-auth-unpwd-fail.py

10 :
	./10-listener-mount-point.py

# Tests for with WITH_STRICT_PROTOCOL defined
strict-test : 
	./01-connect-invalid-id-24.py

=== debian/changelog ===
mosquitto (1.3.4-2) unstable; urgency=low

  * Disable bad "fake ca" test.

 -- Roger A. Light <roger@atchoo.org>  Sat, 16 Aug 2014 10:52:12 +0100

mosquitto (1.3.4-1) unstable; urgency=medium

  * New upstream release: http://mosquitto.org/2014/08/version-1-3-4-released/
   (closes: #725014, #754787)
  * Add dependency on libuuid, c-ares.
  * Bumped standards version to 3.9.5. No changes needed.
  * Example config files are now installed to
    /usr/share/doc/mosquitto/examples/
  * debian/copyright year updated.
  * compiling.txt is no longer distributed.
  * Updated debian/copyright with new dates.

 -- Roger A. Light <roger@atchoo.org>  Wed, 06 Aug 2014 00:43:39 +0100

mosquitto (1.2.1-1) unstable; urgency=low

  * New upstream release: http://mosquitto.org/2013/09/version-1-2-1-released/
  * Add Replaces/Break for libmosquitto-dev and libmosquittopp-dev
    (closes: #720637, #720638).

 -- Roger A. Light <roger@atchoo.org>  Wed, 18 Sep 2013 21:36:01 +0100

mosquitto (1.2-1) unstable; urgency=low

  * New upstream release: http://mosquitto.org/2013/08/version-1-2-released/
    (closes: #685119).
  * Bumped standards release to 3.9.4. No changes needed.
  * Added mosquitto-dbg package for binary debug information.
  * Added python3-mosquitto binary package.
  * Use dh_python2 (and dh_python3) instead of python-support.
  * mosquitto now logs to /var/log/mosquitto/ using logrotate.
  * mosquitto local config should now be placed in /etc/mosquitto/conf.d/

 -- Roger A. Light <roger@atchoo.org>  Wed, 07 Aug 2013 23:26:19 +0100

=== debian/control ===
Source: mosquitto
Section: net
Priority: optional
Maintainer: Roger A. Light <roger@atchoo.org>
Build-Depends: debhelper (>= 9), libc-ares-dev, libssl-dev (>=1.0.0), libwrap0-dev, python-all (>= 2.6.6-3~), python3-all, uthash-dev, uuid-dev
Standards-Version: 3.9.5
Homepage: http://mosquitto.org/
Vcs-Hg: http://bitbucket.org/oojah/mosquitto-packaging
Vcs-Browser: http://bitbucket.org/oojah/mosquitto-packaging/src
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.0

Package: mosquitto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser (>= 3.10), lsb-base (>=4.1+Debian3), libuuid1
Description: MQTT version 3.1/3.1.1 compatible message broker
 This is a message broker that supports version 3.1 and 3.1.1 of the MQTT
 protocol.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquitto1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libc-ares2
Description: MQTT version 3.1 client library
 This is a C library for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquitto-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, libmosquitto1 (>= ${source:Version}), libmosquitto1 (<< ${source:Version}.1~)
Replaces: libmosquitto0-dev (<< 1.2-1~)
Breaks: libmosquitto0-dev (<< 1.2-1~)
Description: MQTT version 3.1 client library, development files
 This is the header and man page for the libmosquitto1 C library, which is a
 library for implementing MQTT version 3.1 clients. This package is needed to do
 development with libmosquitto1.

Package: libmosquittopp1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmosquitto1 (= ${binary:Version})
Description: MQTT version 3.1 client C++ library
 This is a C++ library for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquittopp-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, libmosquittopp1 (>= ${source:Version}), libmosquittopp1 (<< ${source:Version}.1~)
Replaces: libmosquittopp0-dev (<< 1.2-1~)
Breaks: libmosquittopp0-dev (<< 1.2-1~)
Description: MQTT version 3.1 client C++ library, development files
 This is the header and man page for the libmosquittopp1 C++ library, which is
 a library for implementing MQTT version 3.1 clients. This package is needed to
 do development with libmosquittopp1.

Package: mosquitto-clients
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmosquitto1 (= ${binary:Version})
Description: Mosquitto command line MQTT clients
 This is two MQTT version 3.1 command line clients. mosquitto_pub can be used
 to publish messages to a broker and mosquitto_sub can be used to subscribe to
 a topic to receive messages.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: python-mosquitto
Section: python
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}
Description: MQTT version 3.1 Python client library
 This is a Python module for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: python3-mosquitto
Section: python
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: MQTT version 3.1 Python 3 client library
 This is a Python3 module for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: mosquitto-dbg
Architecture: any
Priority: extra
Section: debug
Depends: ${misc:Depends}, mosquitto (= ${binary:Version}) | mosquitto-clients (= ${binary:Version}) | libmosquitto1 (= ${binary:Version}) | libmosquittopp1 (= ${binary:Version})
Description: debugging symbols for mosquitto binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the packages mosquitto, mosquitto-clients,
 libmosquitto1 and libmosquittopp1.

=== debian/rules ===
#!/usr/bin/make -f

PYTHON2=$(shell pyversions -vr)
PYTHON3=$(shell py3versions -vr)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with=python2,python3

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.txt

override_dh_auto_configure:
	# Don't process CMake rules.

override_dh_strip:
	dh_strip --dbg-package=mosquitto-dbg

override_dh_auto_install:
	dh_auto_install
	cd lib/python ; for python in $(PYTHON2) $(PYTHON3); do \
		python$$python setup.py install --install-layout=deb --root=../../debian/tmp; \
	done
	install -d debian/tmp/etc/mosquitto/conf.d/
	install -m 644 debian/README-conf-d debian/tmp/etc/mosquitto/conf.d/README
	install -d debian/tmp/etc/mosquitto/ca_certificates/
	install -m 644 debian/README-ca_certificates debian/tmp/etc/mosquitto/ca_certificates/README
	install -d debian/tmp/etc/mosquitto/certs/
	install -m 644 debian/README-certs debian/tmp/etc/mosquitto/certs/README
	install -m 644 debian/mosquitto.conf debian/tmp/etc/mosquitto/mosquitto.conf

## mosquitto 1.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,17 @@
-# This is a cmake script.
+# This is a cmake script. Process it with the CMake gui or command line utility
+# to produce makefiles / Visual Studio project files on Mac OS X and Windows.
+#
+# To configure the build options either use the CMake gui, or run the command
+# line utility including the "-i" option.
 
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
 project(mosquitto)
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8)
+# Only for version 3 and up. cmake_policy(SET CMP0042 NEW)
 
-set (VERSION 1.3.4)
+set (VERSION 1.4.3)
 
 if (WIN32)
 	execute_process(COMMAND cmd /c echo %DATE% %TIME% OUTPUT_VARIABLE TIMESTAMP
@@ -26,8 +31,9 @@
 	set (INCLUDEDIR include)
 	set (DATAROOTDIR share)
 	set (MANDIR man)
-    set (SHAREDEST .)
-    add_definitions("-D_CRT_SECURE_NO_WARNINGS")
+	set (SHAREDEST .)
+	add_definitions("-D_CRT_SECURE_NO_WARNINGS")
+	add_definitions("-D_CRT_NONSTDC_NO_DEPRECATE")
 else (WIN32)
 	set (BINDIR bin)
 	set (SBINDIR sbin)
@@ -38,6 +44,7 @@
 	endif (${CMAKE_INSTALL_PREFIX} STREQUAL /usr)
 	
 	set (LIBDIR lib${LIB_SUFFIX})
+	set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIBDIR}")
 	set (INCLUDEDIR include)
 	set (DATAROOTDIR share)
 	set (MANDIR ${DATAROOTDIR}/man)
@@ -48,15 +55,27 @@
 	"Include SSL/TLS support?" ON)
 option(WITH_TLS_PSK
 	"Include TLS-PSK support (requires WITH_TLS)?" ON)
+option(WITH_EC
+	"Include Elliptic Curve support (requires WITH_TLS)?" ON)
 if (${WITH_TLS} STREQUAL ON)
 	find_package(OpenSSL REQUIRED)
 	add_definitions("-DWITH_TLS")
+
 	if (${WITH_TLS_PSK} STREQUAL ON)
 		add_definitions("-DWITH_TLS_PSK")
 	endif (${WITH_TLS_PSK} STREQUAL ON)
+
+	if (${WITH_EC} STREQUAL ON)
+		add_definitions("-DWITH_EC")
+	endif (${WITH_EC} STREQUAL ON)
 else (${WITH_TLS} STREQUAL ON)
 	set (OPENSSL_INCLUDE_DIR "")
 endif (${WITH_TLS} STREQUAL ON)
+
+option(WITH_SOCKS "Include SOCKS5 support?" ON)
+if (${WITH_SOCKS} STREQUAL ON)
+	add_definitions("-DWITH_SOCKS")
+endif (${WITH_SOCKS} STREQUAL ON)
 
 option(WITH_SRV "Include SRV lookup support?" ON)

=== man/Makefile ===
--- 
+++ 
@@ -60,6 +60,13 @@
 libmosquitto.3 : libmosquitto.3.xml
 	$(XSLTPROC) $^
 
+html : *.xml
+	set -e; for m in *.xml; \
+		do \
+		hfile=$$(echo $${m} | sed -e 's#\(.*\)\.xml#\1#' | sed -e 's/\./-/g'); \
+		$(XSLTPROC) html.xsl $${m} > $${hfile}.php; \
+	done
+
 potgen :
 	 xml2po -o po/mosquitto/mosquitto.8.pot mosquitto.8.xml
 	 xml2po -o po/mosquitto.conf/mosquitto.conf.5.pot mosquitto.conf.5.xml

=== src/Makefile ===
include ../config.mk

.PHONY: all install uninstall clean reallyclean

ifeq ($(WITH_TLS),yes)
all : mosquitto mosquitto_passwd
else
all : mosquitto
endif

mosquitto : mosquitto.o bridge.o conf.o context.o database.o logging.o loop.o memory_mosq.o persist.o net.o net_mosq.o read_handle.o read_handle_client.o read_handle_server.o read_handle_shared.o security.o security_default.o send_client_mosq.o send_mosq.o send_server.o service.o subs.o sys_tree.o time_mosq.o tls_mosq.o util_mosq.o websockets.o will_mosq.o
	${CROSS_COMPILE}${CC} $^ -o $@ ${LDFLAGS} $(BROKER_LIBS)

mosquitto.o : mosquitto.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

bridge.o : bridge.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
conf.o : conf.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
context.o : context.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

database.o : database.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

logging.o : logging.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

loop.o : loop.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

memory_mosq.o : ../lib/memory_mosq.c ../lib/memory_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

net.o : net.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

net_mosq.o : ../lib/net_mosq.c ../lib/net_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
persist.o : persist.c persist.h mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
read_handle.o : read_handle.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_client.o : read_handle_client.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_server.o : read_handle_server.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_shared.o : ../lib/read_handle_shared.c ../lib/read_handle.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

security.o : security.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

security_default.o : security_default.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_client_mosq.o : ../lib/send_client_mosq.c ../lib/send_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_mosq.o : ../lib/send_mosq.c ../lib/send_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_server.o : send_server.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

service.o : service.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

subs.o : subs.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

sys_tree.o : sys_tree.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

time_mosq.o : ../lib/time_mosq.c ../lib/time_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

tls_mosq.o : ../lib/tls_mosq.c
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

util_mosq.o : ../lib/util_mosq.c ../lib/util_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

websockets.o : websockets.c mosquitto_broker.h
	${CC} $(BROKER_CFLAGS) -c $< -o $@

will_mosq.o : ../lib/will_mosq.c ../lib/will_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

mosquitto_passwd : mosquitto_passwd.o
	${CROSS_COMPILE}${CC} $^ -o $@ ${LDFLAGS} $(PASSWD_LIBS)

mosquitto_passwd.o : mosquitto_passwd.c
	${CROSS_COMPILE}${CC} $(CFLAGS) ${CPPFLAGS} -c $< -o $@

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/sbin
	$(INSTALL) -s --strip-program=${CROSS_COMPILE}${STRIP} mosquitto ${DESTDIR}${prefix}/sbin/mosquitto
	$(INSTALL) mosquitto_plugin.h ${DESTDIR}${prefix}/include/mosquitto_plugin.h
ifeq ($(WITH_TLS),yes)
	$(INSTALL) -s --strip-program=${CROSS_COMPILE}${STRIP} mosquitto_passwd ${DESTDIR}${prefix}/bin/mosquitto_passwd
endif

uninstall :
	-rm -f ${DESTDIR}${prefix}/sbin/mosquitto
	-rm -f ${DESTDIR}${prefix}/include/mosquitto_plugin.h
	-rm -f ${DESTDIR}${prefix}/bin/mosquitto_passwd

clean : 
	-rm -f *.o mosquitto mosquitto_passwd

reallyclean : clean
	-rm -rf *.orig *.db

=== debian/changelog ===
mosquitto (1.4.3-1) unstable; urgency=low

  * New upstream release.
  * New binary package mosquitto-dev.
  * python3-mosquitto and python-mosquitto packages removed because the python
    module is no longer part of upstream.
  * Remove unused patches (pynomake.patch and disable-bad-test.patch)
  * Added dependency on libwebsockets3, uuid. Note that the source package
    will build (and actually prefers) using libwebsockets4 when it becomes
    available. This adds the patch enable-websockets.patch.
  * Upstream license has changed from BSD-3 to EPL-1.0 or EDL-1.0.
  * Fix log directory permissions.
  * Port to multiarch (closes: #763385) - adds libdir.patch
  * Symbols update
  * Patch refresh
  * Add build-timestamp.patch to create reproducable builds.
  * Add support for apparmor.

 -- Roger A. Light <roger@atchoo.org>  Wed, 19 Aug 2015 10:31:10 +0100

=== debian/control ===
Source: mosquitto
Section: net
Priority: optional
Maintainer: Roger A. Light <roger@atchoo.org>
Build-Depends: debhelper (>= 9), libc-ares-dev, libssl-dev (>=1.0.0), libwebsockets-dev (>=1.2), libwrap0-dev, python-all (>= 2.6.6-3~), uthash-dev, uuid-dev
Standards-Version: 3.9.6
Homepage: http://mosquitto.org/
Vcs-Git: http://git.eclipse.org/r/mosquitto/org.eclipse.mosquitto
Vcs-Browser: http://git.eclipse.org/c/mosquitto/org.eclipse.mosquitto.git

Package: mosquitto
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser (>= 3.10), lsb-base (>=4.1+Debian3), libuuid1, apparmor
Description: MQTT version 3.1/3.1.1 compatible message broker
 This is a message broker that supports version 3.1 and 3.1.1 of the MQTT
 protocol.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: mosquitto-dev
Section: devel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, mosquitto (>= ${source:Version}), mosquitto (<< ${source:Version}.1~)
Description: Development files for Mosquitto
 Mosquitto is a message broker that supports the MQTT protocol.
 .
 This package contains the include files used if you wish to compile a package
 which requires Mosquitto's source file headers. 

Package: libmosquitto1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libc-ares2
Description: MQTT version 3.1 client library
 This is a C library for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquitto-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmosquitto1 (>= ${source:Version}), libmosquitto1 (<< ${source:Version}.1~)
Replaces: libmosquitto0-dev (<< 1.2-1~)
Breaks: libmosquitto0-dev (<< 1.2-1~)
Description: MQTT version 3.1 client library, development files
 This is the header and man page for the libmosquitto1 C library, which is a
 library for implementing MQTT version 3.1 clients. This package is needed to do
 development with libmosquitto1.

Package: libmosquittopp1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libmosquitto1 (= ${binary:Version})
Description: MQTT version 3.1 client C++ library
 This is a C++ library for implementing MQTT version 3.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquittopp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmosquittopp1 (>= ${source:Version}), libmosquittopp1 (<< ${source:Version}.1~)
Replaces: libmosquittopp0-dev (<< 1.2-1~)
Breaks: libmosquittopp0-dev (<< 1.2-1~)
Description: MQTT version 3.1 client C++ library, development files
 This is the header and man page for the libmosquittopp1 C++ library, which is
 a library for implementing MQTT version 3.1 clients. This package is needed to
 do development with libmosquittopp1.

Package: mosquitto-clients
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libmosquitto1 (= ${binary:Version})
Description: Mosquitto command line MQTT clients
 This is two MQTT version 3.1 command line clients. mosquitto_pub can be used
 to publish messages to a broker and mosquitto_sub can be used to subscribe to
 a topic to receive messages.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: mosquitto-dbg
Architecture: any
Multi-Arch: foreign
Priority: extra
Section: debug
Depends: ${misc:Depends}, mosquitto (= ${binary:Version}) | mosquitto-clients (= ${binary:Version})
Description: debugging symbols for mosquitto binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the packages mosquitto, mosquitto-clients,
 libmosquitto1 and libmosquittopp1.

Package: libmosquitto1-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends: ${misc:Depends}, libmosquitto1 (= ${binary:Version})
Description: debugging symbols for libmosquitto binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the libmosquitto1 package.

Package: libmosquittopp1-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends: ${misc:Depends}, libmosquittopp1 (= ${binary:Version})
Description: debugging symbols for libmosquittopp binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the libmosquittopp1 package.

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with=python2,python3
+	dh $@
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog.txt
@@ -14,14 +14,15 @@
 override_dh_auto_configure:
 	# Don't process CMake rules.
 
+override_dh_auto_test:
+
 override_dh_strip:
-	dh_strip --dbg-package=mosquitto-dbg
+	dh_strip --dbg-package=mosquitto-dbg -Xlibmosquitto
+	dh_strip --dbg-package=libmosquitto1-dbg -Xlibmosquittopp -Xsbin/mosquitto
+	dh_strip --dbg-package=libmosquittopp1-dbg -Xlibmosquitto.so -Xsbin/mosquitto
 
 override_dh_auto_install:
 	dh_auto_install
-	cd lib/python ; for python in $(PYTHON2) $(PYTHON3); do \
-		python$$python setup.py install --install-layout=deb --root=../../debian/tmp; \
-	done
 	install -d debian/tmp/etc/mosquitto/conf.d/
 	install -m 644 debian/README-conf-d debian/tmp/etc/mosquitto/conf.d/README
 	install -d debian/tmp/etc/mosquitto/ca_certificates/
